/// <reference types="node" />
import * as LINEBot from '@line/bot-sdk';
import { DotenvConfigOptions } from 'dotenv';
import { ErrorRequestHandler, Express, RequestHandler } from 'express';
import * as https from 'https';
import { BotServerOptions } from './bot-server-options';
export declare class BotServer {
    static defaultSSLKey: string;
    static defaultSSLCert: string;
    static generateDefaultSSLAsync(sslDir: string, days?: number, selfSigned?: boolean): Promise<{}>;
    static getEnvOptions(options?: DotenvConfigOptions): BotServerOptions;
    static generateEnvFile(fileName: string, options?: BotServerOptions): void;
    options: BotServerOptions;
    client: LINEBot.Client;
    clientConfig: LINEBot.ClientConfig;
    app: Express;
    https: https.Server;
    constructor(options?: BotServerOptions);
    enableStatusEndpoint(): void;
    setWebhook(endpoint: string, callback: RequestHandler | ErrorRequestHandler): void;
    start(): void;
}
